<template>
    <v-container fluid>
        <v-card max-width="1200px" class="ma-auto pa-8">
            <v-card-title>Rule List</v-card-title>
            <v-data-table :headers="headers" :items="rules" :items-per-page="20" :elevation="1">
                <template v-slot:item.labels="{ item }">
                    <div>
                        <v-chip v-for="l in item.labels">
                            {{l}}
                        </v-chip>
                    </div>
                </template>
                <template v-slot:item.triggerType="{ item }">
                    {{ FormatTriggerType(item.triggerType)}}
                </template>
            </v-data-table>
            <v-tooltip bottom>
                <template #activator="{ on, attrs }">
                    <v-btn color="pink" dark absolute bottom right fab v-bind="attrs" v-on="on" to="/rule/create">
                        <v-icon>mdi-plus</v-icon>
                    </v-btn>
                </template>
                <span>Create Rule</span>
            </v-tooltip>
        </v-card>

    </v-container>
</template>

<script lang='ts'>
    import {Component} from 'vue-property-decorator';
    import {Validable} from "../../mixins/Validable";
    import {Initializable} from "../../mixins/Initializable";
    import {Mixins} from "vue-mixin-decorator";
    import {RawLocation} from "vue-router";
    import {coreApi, triggerType} from "../../init";
    import {RulePrincipalResponse} from "../../../../classLibrary/core/rulePrincipalResponse";

    interface AnalyticsMixin extends Validable, Initializable {
    }


    @Component
    export default class RuleList extends Mixins<AnalyticsMixin>(Validable, Initializable) {

        rules: RulePrincipalResponse[] = [];
        labels: string[] = [];


        headers = [
            {
                text: 'Name',
                align: 'start',
                sortable: true,
                value: 'name',
            },
            {
                text: 'Description',
                align: 'start',
                sortable: false,
                value: 'description',
            },
            {
                text: 'Labels',
                align: 'start',
                sortable: false,
                value: 'labels',
            },
            {
                text: 'Trigger Type',
                align: 'center',
                sortable: false,
                value: 'triggerType'
            },
        ]

        // Parameters

        searchTarget?: string;
        label?: string;
        triggerType?: string;


        updateQuery() {
            const route: RawLocation = {
                name: 'triggers',
                query: {}
            }
            if (!this.label?.IsEmpty()) route.query!['label'] = this.label;
            if (!this.searchTarget?.IsEmpty()) route.query!['search'] = this.searchTarget;
            if (!this.triggerType?.IsEmpty()) route.query!['triggerType'] = this.triggerType;

        }

        loadQuery() {
            const query = this.$route.query;
            this.label = query.label as any;
            this.searchTarget = query.search as any;
            this.triggerType = query.triggerType as any;
        }

        FormatTriggerType(v: string): string {
            return triggerType.Find(x => x.value === v)?.name ?? "";
        }


        async init() {
            this.loadQuery();
            const labelsResult = await coreApi.Get<string[]>('Rule/labels')
            if (!labelsResult.success) {
                await this.$router.push("notfound?action-labels-failed");
            }
            const ruleResult = await coreApi.Get<RulePrincipalResponse[]>('Rule');
            if (ruleResult.success) {
                this.rules = ruleResult.Ok!;
            }
        }
    }
</script>
